freeslot("sfx_tdjump")
sfxinfo[sfx_tdjump].caption = "Rising"
freeslot("sfx_tdjmp2")
sfxinfo[sfx_tdjmp2].caption = "Rising"
freeslot("sfx_tdslow")
sfxinfo[sfx_tdslow].caption = "Float"
freeslot("sfx_tdshld")
sfxinfo[sfx_tdshld].caption = "Poly Barrier"
freeslot("sfx_tdblck")
sfxinfo[sfx_tdblck].caption = "Protection"
freeslot("sfx_tdlose")
sfxinfo[sfx_tdlose].caption = "/"
freeslot("sfx_tdrecg")
sfxinfo[sfx_tdrecg].caption = "Recharge"
freeslot("sfx_tdchrg")
sfxinfo[sfx_tdchrg].caption = "Wind-up"
freeslot("sfx_tdshn1")
sfxinfo[sfx_tdshn1].caption = "Blip"
freeslot("sfx_tdshn2")
sfxinfo[sfx_tdshn2].caption = "/"
freeslot("sfx_tdshn3")
sfxinfo[sfx_tdshn3].caption = "Recharge"
freeslot("sfx_tdshn4")
sfxinfo[sfx_tdshn4].caption = "Protection"
freeslot("sfx_tdexpl")
sfxinfo[sfx_tdexpl].caption = "Explosion"
freeslot("sfx_tdchg2")
sfxinfo[sfx_tdchg2].caption = "Wind-up"
freeslot("sfx_tdlazr")
sfxinfo[sfx_tdlazr].caption = "Firing bullet"

freeslot("SPR_TDLP", "SPR_TDSH", "SPR_TDCR")

//Circle effect
freeslot("S_TAILSDOLL_CIRCLE")
states[S_TAILSDOLL_CIRCLE] = {SPR_TDCR, FF_ANIMATE, 12, nil, 5, 2, S_NULL}

//Followitem used for Tails Doll
freeslot("MT_TAILSDOLL_CRYSTAL")
mobjinfo[MT_TAILSDOLL_CRYSTAL] = {
	spawnstate = S_INVISIBLE,
	spawnhealth = 1000,
	radius = 8*FRACUNIT,
	height = 8*FRACUNIT,
	flags = MF_SCENERY|MF_NOGRAVITY|MF_NOBLOCKMAP|MF_NOCLIPTHING|MF_NOCLIPHEIGHT
}

//Attachments to the different parts of Tails Doll
freeslot("MT_TAILSDOLL_PART", "MT_TAILSDOLL_PART2")
mobjinfo[MT_TAILSDOLL_PART] = {
	spawnstate = S_INVISIBLE,
	deathstate = S_INVISIBLE,
	spawnhealth = 1000,
	radius = 8*FRACUNIT,
	height = 8*FRACUNIT,
	speed = 1,
	flags = MF_SCENERY|MF_NOBLOCKMAP|MF_NOCLIPTHING|MF_NOCLIP|MF_NOCLIPHEIGHT,
	dispoffset = 1
}

//Tails Doll's Poly Shield
freeslot("MT_TAILSDOLL_SHIELD", "S_TAILSDOLL_SHIELD")
states[S_TAILSDOLL_SHIELD] = {SPR_TDSH, FF_ANIMATE, -1, nil, 3, 2, S_NULL}
mobjinfo[MT_TAILSDOLL_SHIELD] = {
	doomednum = -1,
	spawnstate = S_INVISIBLE,
	spawnhealth = 1,
	speed = 1,
	radius = 64*FRACUNIT,
	height = 96*FRACUNIT,
	flags = MF_NOBLOCKMAP|MF_NOGRAVITY|MF_NOCLIP|MF_NOCLIPHEIGHT
}

//tdsecret command
COM_AddCommand("tdsecret", function(player, arg)
	if arg and arg == "fiyah" //You freakin' cheater, peeping in here!
		player.tdsecret = true
	else
		player.tdsecret = false
	end
end, 0)

//Command to disable Tails Doll's splat effects
local tdsplat = {}
tdsplat.value = false
if MF2_SPLAT
	tdsplat = CV_RegisterVar({
		name = "tdsplat",
		defaultvalue = "On",
		flags = CV_NETVAR,
		PossibleValue = CV_OnOff
	})
end

local verydangerouschasecamvariable = true
hud.add(function(v, player, cam)
	verydangerouschasecamvariable = cam.chase
end)

if not TailsDollShieldColors
    rawset(_G, "TailsDollShieldColors", {})
end
TailsDollShieldColors[SH_PITY] = SKINCOLOR_MOSS
TailsDollShieldColors[SH_PINK] = SKINCOLOR_ROSY
TailsDollShieldColors[SH_ARMAGEDDON] = SKINCOLOR_SUPERORANGE1
TailsDollShieldColors[SH_ATTRACT] = SKINCOLOR_GOLD
TailsDollShieldColors[SH_ELEMENTAL] = SKINCOLOR_FLAME
TailsDollShieldColors[SH_FORCE] = SKINCOLOR_DUSK
TailsDollShieldColors[SH_FORCE|1] = SKINCOLOR_PURPLE
TailsDollShieldColors[SH_WHIRLWIND] = SKINCOLOR_GREY
TailsDollShieldColors[SH_FLAMEAURA] = SKINCOLOR_KETCHUP
TailsDollShieldColors[SH_BUBBLEWRAP] = SKINCOLOR_BLUE
TailsDollShieldColors[SH_THUNDERCOIN] = SKINCOLOR_WHITE

if not TailsDollInnerColors
    rawset(_G, "TailsDollInnerColors", {})
end
TailsDollInnerColors[SH_PITY] = SKINCOLOR_GREEN
TailsDollInnerColors[SH_ARMAGEDDON] = SKINCOLOR_CRIMSON
TailsDollInnerColors[SH_ATTRACT] = SKINCOLOR_SUPERGOLD5
TailsDollInnerColors[SH_ELEMENTAL] = SKINCOLOR_BLUE
TailsDollInnerColors[SH_WHIRLWIND] = SKINCOLOR_CARBON
TailsDollInnerColors[SH_THUNDERCOIN] = SKINCOLOR_OLIVE

rawset(_G, "GetTDShieldColor", function(player, inner)
	local color = TailsDollShieldColors[(player.powers[pw_shield] & SH_NOSTACK)]
	if inner
		color = TailsDollInnerColors[(player.powers[pw_shield] & SH_NOSTACK)] or $
	end
	
	if player.powers[pw_super] > 1
		return player.mo.color-5
	elseif color != nil
		if color >= SKINCOLOR_SUPERSILVER1
		and color % 5 == SKINCOLOR_SUPERSILVER1 % 5 //Super color
			color = $ + abs( ( (leveltime >> 1) % 9) - 4)
		end
		return color
	elseif player.powers[pw_shield]
		return SKINCOLOR_GREEN
	else
		return SKINCOLOR_RED
	end
end)

//Get the player's input angle
local function inputangle(player)
	if P_GetPlayerControlDirection(player) == 0
	or player.mo.flags2 & MF2_TWOD or twodlevel
		return player.drawangle
	else 
		return player.cmd.angleturn<<16 + R_PointToAngle2(0, 0, player.cmd.forwardmove*FRACUNIT, -player.cmd.sidemove*FRACUNIT)
	end
end

//Spawns objects in a circle
local function tdcircle(mobj, mobjtype, ns, zoffset, scale, keepmom, color, vertical, vertangle)
	local i = 0	while i < 8
		local fa = (i*(ANGLE_180/4))
		local mo = P_SpawnMobjFromMobj(mobj,0,0,zoffset,mobjtype)
		if mo and mo.valid
			local height = mo.height
			mo.scale = scale
			if mobj.eflags&MFE_VERTICALFLIP
				mo.z = $-(mo.height-height)
			end
			if color
				mo.color = color
				mo.colorized = true
			end
			if vertical
				mo.momz = FixedMul(sin(fa),ns)/2
				P_InstaThrust(mo, vertangle+ANGLE_90,
				FixedMul(cos(fa),ns)/2)
			else
				mo.momx = FixedMul(sin(fa),ns)/2
				mo.momy = FixedMul(cos(fa),ns)/2
			end
			if keepmom
				mo.momx = $+mobj.momx
				mo.momy = $+mobj.momy
				mo.momz = $+mobj.momz
			end
		end
		i = $+1
	end
end

//Draw links
local drawinbetween = function(mobj, target, sprite, number, hor, z)
	local xoffset = P_ReturnThrustX(nil, mobj.angle+ANGLE_90, hor*2/3)+target.x
	local yoffset = P_ReturnThrustY(nil, mobj.angle+ANGLE_90, hor*2/3)+target.y
			
	// Get distance for each step
	local distX = (xoffset - mobj.x) / number+1
	local distY = (yoffset - mobj.y) / number+1
	
	local distZ = target.z + z*P_MobjFlip(mobj) - mobj.z
	if mobj.eflags&MFE_VERTICALFLIP
		distZ = $+target.height-mobj.height
	end
	if mobj.reactiontime == 1
		distZ = ($ - (target.height + mobj.height)*P_MobjFlip(mobj)*23/40) / number+1
		number = $-1
	else
		distZ = $ / number+1
	end
			
	local i = 1 while (i <= number)
		//print(i)
		local part = P_SpawnMobj(mobj.x + distX * i, mobj.y + distY * i,
		mobj.z + mobj.height/2 + distZ * i, MT_CYBRAKDEMON_TARGET_DOT)
		
		part.height = mobj.scale
		part.flags2 = mobj.flags2&(MF2_DONTDRAW|MF2_OBJECTFLIP)
		part.eflags = mobj.eflags&MFE_VERTICALFLIP
		part.color = mobj.color
		part.colorized = mobj.colorized
		if (i == 1 and mobj.reactiontime >= 5)
		or mobj.reactiontime == 1
			part.color = SKINCOLOR_BONE
		end
		if sprite
			part.sprite = SPR_THOK
			part.frame = FF_FULLBRIGHT
			part.scale = mobj.scale
			/*if mobj.target and mobj.target.valid and mobj.target.fuse%2
			and mobj.target.scale != mobj.target.destscale
				local ghost = P_SpawnGhostMobj(part)
				ghost.fuse = 4
				ghost.destscale = ghost.scale*128
				ghost.scalespeed = ghost.scale/2
				P_SetScale(ghost, ghost.scale+ghost.scalespeed)
			end*/
		else
			part.sprite = SPR_TDLP
			part.frame = 7
			part.scale = mobj.scale
		end
		part.tracer = mobj
		part.fuse = 1
		
		i = $+1
	end
end

local function tdnosplat(player)
	return not tdsplat.value and not player.tdsecret
end

local TDDiv = function(num1, num2, scale)
	return FixedMul(FixedDiv(FixedDiv(num1, scale), FixedDiv(num2, scale)), scale)
end

local shieldblock = function(mo)
	local player = mo.player
	S_StartSound(mo, player.tdsecret and sfx_tdshn4 or sfx_tdblck)
	if player.tdsecret
		for i=1, 8
			local fa = (i*(ANGLE_180/4))
			local spoark = P_SpawnMobjFromMobj(mo, 0,0,player.height/2, MT_SUPERSPARK)
			if spoark and spoark.valid
				spoark.scale = $/2
				spoark.momx = FixedMul(sin(fa),8*mo.scale)
				spoark.momy = FixedMul(cos(fa),8*mo.scale)
			end
		end
	end
	P_SetScale(player.dollshield, tdnosplat(player) and mo.scale*5/2 or mo.scale*3/2)
	player.dollshield.fuse = max($,8)
end

local shieldparry = function(target, inflictor, source)
	local player = target and target.valid and target.player
	if not (player and player.dollshield
	and player.dollshield.valid and player.dolldelay) return end
	
	local inflictorvalid = inflictor and inflictor.valid
	local sourcevalid = source and source.valid
	local targetvalid = inflictorvalid and inflictor.target and inflictor.target.valid
	
	if player.dollshield.scale <= (tdnosplat(player) and target.scale*3/2 or target.scale)
		shieldblock(target)
		if inflictorvalid
			target.momz = abs($)*P_MobjFlip(target)
		end
	end
	
	if CBW_Battle and CBW_Battle.PlayerCanBeDamaged(player)
	and inflictorvalid and (inflictor.player
	or (inflictor.flags & MF_MISSILE and targetvalid
	and inflictor.target.player and inflictor.blockable != 1))
		local angle = R_PointToAngle2(inflictor.x-inflictor.momx,inflictor.y-inflictor.momy,target.x-target.momx,target.y-target.momy)
		local thrust = FRACUNIT*10
		if twodlevel then thrust = CBW_Battle.TwoDFactor($) end
		P_SetObjectMomZ(target,thrust)
		CBW_Battle.DoPlayerTumble(target.player, 45, angle, target.scale*3, true)
		player.powers[pw_flashing] = 5
	elseif inflictorvalid and inflictor.flags & MF_MISSILE
	and targetvalid and inflictor.target != target
	and not (inflictor.flags & (MF_NOCLIPTHING|MF_PAIN))
	and not (player.tdparries and player.tdparries >= 8)
		player.tdparries = $ and $+1 or 1
		
		local missile
		if sourcevalid
			missile = P_SpawnPointMissile(target,
			source.x, source.y, source.z,
			MT_JETTBULLET, target.x, target.y, target.z + target.height/2)
		elseif targetvalid
			missile = P_SpawnPointMissile(target,
			inflictor.target.x, inflictor.target.y, inflictor.target.z,
			MT_JETTBULLET, target.x, target.y, target.z + target.height/2)
		elseif inflictor.momx or inflictor.momy
			missile = P_SPMAngle(target, MT_JETTBULLET,
			R_PointToAngle2(inflictor.momx, inflictor.momy, 0,0), 0)
		else
			missile = P_SPMAngle(target, MT_JETTBULLET, target.angle, 0)
		end
		
		if missile and missile.valid
			missile.color = GetTDShieldColor(player)
			missile.colorized = true
			if player.tdsecret
				S_StartSound(target,sfx_tdlazr)
			else
				S_StartSound(target,sfx_s3k4d)
			end
		end
		
		inflictor.target = nil
		inflictor.flags = $|MF_NOCLIP|MF_NOCLIPTHING&~MF_SPECIAL&~MF_MISSILE
		inflictor.state = S_INVISIBLE
		inflictor.tics = 1
	end
	return false
end

//I'm allowed to steal my own code, right?
local nuketdshield = function(player, radius)
	local mo = player.mo
	local thokmobj = P_SpawnMobjFromMobj(mo, 0,0,0, MT_THOK)
	thokmobj.radius = radius
	thokmobj.flags2 = $|MF2_DONTDRAW
	searchBlockmap("objects", function(refmobj, mobj)
		if not (mobj and mobj.valid and mobj.health and mobj != mo)
			return
		end
		
		if not P_PlayerCanDamage(player, mobj) or mobj.flags&(MF_NOCLIP|MF_NOCLIPTHING)
			return
		end
		
		if not (mobj.flags & (MF_SHOOTABLE|MF_PAIN|MF_MISSILE|MF_SPRING) or mobj.battleobject)
		and mobj.type != MT_EGGGUARD and mobj.type != MT_MINUS
		and mobj.type != MT_METALSONIC_BATTLE and mobj.type != MT_WALLSPIKE
		and mobj.type != MT_SPIKE
			return
		end
		
		if mobj.flags & MF_SPRING and player.powers[pw_justsprung] then return end

		if mobj.player
			if mobj.player.spectator or mobj.flags&(MF_NOCLIP|MF_NOCLIPTHING)
				return
			elseif not CV_FindVar("friendlyfire").value
			and G_GametypeHasTeams() and mobj.player.ctfteam == player.ctfteam
				return
			elseif G_TagGametype() and (mobj.player.pflags & PF_TAGIT) == (player.pflags & PF_TAGIT)
				return
			elseif not CV_FindVar("friendlyfire").value and not G_RingSlingerGametype()
			and not (CBW_Battle and CBW_Battle.BattleGametype())
				return
			end
		end

		if abs(mo.x - mobj.x) > radius or abs(mo.y - mobj.y) > radius or abs(mo.z - mobj.z) > radius
			return // Workaround for possible integer overflow in the below -Red
		end

		if FixedHypot(R_PointToDist2(mo.x, mo.y, mobj.x, mobj.y),
		mo.z - mobj.z) > radius
			return
		end
		
		if mobj.type == MT_SPIKE or mobj.type == MT_WALLSPIKE
			P_KillMobj(mobj, mo, mo) //just murder spikes!
			return
		end
		
		//Let's spring on these guys instead of killing them
		if (mobj.type == MT_SPRINGSHELL or mobj.type == MT_YELLOWSHELL)
		and ((mobj.eflags & MFE_VERTICALFLIP and mobj.z >= mo.z+mo.height)
		or (not (mobj.eflags & MFE_VERTICALFLIP) and mobj.z+mobj.height <= mo.z))
			if not player.powers[pw_justsprung]
				P_DoSpring(mobj, mo)
			end
			return
		end
		
		//That's right, we're doing this the hard way.
		if mobj.type == MT_METALSONIC_BATTLE and mobj.state == S_METALSONIC_FLOAT
			mobj.movedir = ANGLE_11hh - FixedAngle(FixedMul(AngleFixed(ANGLE_11hh),
			FixedDiv((mobj.info.spawnhealth - mobj.health)<<FRACBITS, (mobj.info.spawnhealth-1)<<FRACBITS)))
			if (P_RandomChance(FRACUNIT/2)) then mobj.movedir = InvAngle(mobj.movedir) end
			mobj.threshold = 6 + (FixedMul(24<<FRACBITS, FixedDiv((mobj.info.spawnhealth - mobj.health)<<FRACBITS, (mobj.info.spawnhealth-1)<<FRACBITS))>>FRACBITS)
			if (mobj.info.activesound) then S_StartSound(mobj, mobj.info.activesound) end
			if (mobj.info.painchance) then mobj.state = mobj.info.painchance end
			mobj.flags2 = $ & ~MF2_INVERTAIMABLE
			
		elseif mobj.player and CBW_Battle and CBW_Battle.BattleGametype()
			CBW_Battle.PlayerTouch(mo,mobj)
			
		elseif mobj.battleobject and CBW_Battle
			CBW_Battle.BashableCollision(mobj, mo)
			
		elseif mobj.flags & MF_SPRING
			P_DoSpring(mobj, mo)
			
		elseif not (mobj.flags & MF_SHOOTABLE) and mobj.flags & (MF_PAIN|MF_MISSILE)
			if mobj.flags & MF_MISSILE
				shieldparry(mo, mobj, mobj.target)
			else
				shieldparry(mo, mobj, mobj)
			end
			
		//Unlike the orignal script this always deals one damage, no matter what
		else
			if mobj.player and mobj.player.guard == -1
				mobj.player.guard = 0
				mobj.player.guardtics = 0
			end
			P_DamageMobj(mobj, mo, mo, 1, 0)
		end
	end, thokmobj)
end

//Spawn in all the parts of Tails Doll
addHook("MobjSpawn", function(mobj)
	//Reactiontime is the object type
	//Threshold is the horizontal offset
	//Cusval determines the vertical offset
	
	//Head
	mobj.target = P_SpawnMobjFromMobj(mobj,0,0,0,MT_TAILSDOLL_PART)
	mobj.target.height = $*14/3
	mobj.target.radius = $*2
	mobj.target.cusval = 8
	mobj.target.target = mobj
	mobj.target.hprev = mobj
	//Body
	local body = P_SpawnMobjFromMobj(mobj.target,0,0,0,MT_TAILSDOLL_PART)
	body.shadowscale = FRACUNIT*2
	body.cusval = -1
	body.target = mobj.target
	body.hprev = mobj
	//Right Hand
	local righthand = P_SpawnMobjFromMobj(body,0,0,0,MT_TAILSDOLL_PART)
	righthand.threshold = 12
	righthand.cusval = 0
	righthand.target = body
	righthand.hprev = mobj
	//righthand.flags2 = $|MF2_LINKDRAW
	//Left Hand
	local lefthand = P_SpawnMobjFromMobj(body,0,0,0,MT_TAILSDOLL_PART)
	lefthand.threshold = -12
	lefthand.cusval = 0
	lefthand.target = body
	lefthand.hprev = mobj
	//Right Foot
	local rightfoot = P_SpawnMobjFromMobj(body,0,0,0,MT_TAILSDOLL_PART)
	rightfoot.threshold = 4
	rightfoot.cusval = -8
	rightfoot.target = body
	rightfoot.hprev = mobj
	//Left Foot
	local leftfoot = P_SpawnMobjFromMobj(body,0,0,0,MT_TAILSDOLL_PART)
	leftfoot.threshold = -4
	leftfoot.cusval = -8
	leftfoot.target = body
	leftfoot.hprev = mobj
	//Right Tail
	local righttail = P_SpawnMobjFromMobj(body,0,0,0,MT_TAILSDOLL_PART)
	righttail.threshold = 4
	righttail.cusval = 8
	righttail.target = body
	righttail.hprev = mobj
	//Left Tail
	local lefttail = P_SpawnMobjFromMobj(body,0,0,0,MT_TAILSDOLL_PART)
	lefttail.threshold = -4
	lefttail.cusval = 8
	lefttail.target = body
	lefttail.hprev = mobj
	
	mobj.tailsdollparts = {mobj.target, body, righthand, lefthand,
	rightfoot, leftfoot, righttail, lefttail}
	
	for i, part in ipairs(mobj.tailsdollparts)
		if part and part.valid
			part.reactiontime = i
		end
	end
end, MT_TAILSDOLL_CRYSTAL)

//Thinker for the main crystal
addHook("FollowMobj", function(player, mobj)
	if not (player.mo and player.mo.valid and player.mo.skin == "tailsdoll"
	and mobj and mobj.valid) return true end
	mobj.skin = player.mo.skin
	mobj.sprite = SPR_TDLP
	mobj.frame = 2
	if player.pflags&PF_DIRECTIONCHAR
		mobj.angle = player.drawangle
	else
		mobj.angle = R_PointToAngle2(0,0,player.mo.momx,player.mo.momy)
	end
	mobj.color = player.mo.color
	mobj.colorized = player.mo.colorized
	mobj.scale = player.mo.scale
	mobj.flags2 = player.mo.flags2&(MF2_DONTDRAW|MF2_OBJECTFLIP)
	mobj.eflags = player.mo.eflags&MFE_VERTICALFLIP
	//player.mo.flags2 = $|MF2_DONTDRAW
	mobj.flags2 = $&~MF2_LINKDRAW
	
	local sprite2 = player.mo.sprite2&~FF_SPR2SUPER&~FF_SPR2ENDSTATE&~FF_SPR2MIDSTART
	if player.powers[pw_carry] == CR_NIGHTSMODE or player.armachargeup
	or sprite2 == SPR2_TRNS or sprite2 == SPR2_CNT1 or sprite2 == SPR2_NDRL
	or sprite2 == SPR2_NFLY or sprite2 == SPR2_NPUL or player.tumble
	or player.mo.spr_pit or player.mo.spr_nfloor
		mobj.flags2 = $|MF2_DONTDRAW
		mobj.sprite = 0
	else
		player.mo.sprite = 0
	end
	
	if player == displayplayer and not verydangerouschasecamvariable
		mobj.flags2 = $|MF2_DONTDRAW
	end
	
	mobj.momx = player.mo.momx
	mobj.momy = player.mo.momy
	mobj.momz = player.mo.momz
	
	if mobj.eflags&MFE_VERTICALFLIP
		P_TeleportMove(mobj,player.mo.x,player.mo.y,player.mo.z-(player.mo.height*1/10)-mobj.height)
	else
		P_TeleportMove(mobj,player.mo.x,player.mo.y,player.mo.z+(player.mo.height*10/9))
	end
	
	if player.powers[pw_shield] & SH_NOSTACK or player.powers[pw_super] > 1
		mobj.color = GetTDShieldColor(player)
		mobj.colorized = true
		if P_RandomChance(FRACUNIT/4)
			local r = mobj.radius>>FRACBITS
			local x = mobj.x+(P_RandomRange(r, -r)<<FRACBITS)
			local y = mobj.y+(P_RandomRange(r, -r)<<FRACBITS)
			local z = mobj.z+(P_RandomKey(mobj.height>>FRACBITS)<<FRACBITS)
			local zap = P_SpawnMobj(x, y, z, MT_WATERZAP)
			zap.scale = mobj.scale
			S_StartSoundAtVolume(mobj, sfx_beelec, 24, player)
			zap.momx = mobj.momx
			zap.momy = mobj.momy
			zap.momz = mobj.momz
			zap.color = mobj.color
			zap.colorized = true
		end
	elseif not mobj.colorized
		mobj.color = SKINCOLOR_RED
	end
	
	local jumpin = (player.cmd.buttons&BT_JUMP and player.fly1
	and player.pflags&PF_JUMPED and player.pflags&PF_STARTJUMP
	and player.mo.momz*P_MobjFlip(player.mo) > 0)
	or (player.secondjump == 1 and player.cmd.buttons&BT_JUMP)
	or player.actionstate or (player.dolldelay and player.dolldelay > TICRATE*4/5)
	
	if player.speed > FixedMul(player.runspeed, player.mo.scale)
		if jumpin
			mobj.frame = 19
		else
			mobj.frame = 12
		end
	elseif jumpin
		mobj.frame = 18
	end
	
	if jumpin and (not ((player.fly1+1)%5) or (player.secondjump == 1 and not (player.glidetime%12)))
		local circle = nil
		if tdsplat.value
			circle = P_SpawnMobjFromMobj(mobj, 0,0, 8*FRACUNIT, MT_THOK)
			circle.target = mobj
			circle.tracer = mobj
			circle.color = mobj.color
			circle.flags2 = $|MF2_SPLAT
			if circle.eflags & MFE_VERTICALFLIP
				circle.z = $ + circle.height
			end
			circle.state = S_TAILSDOLL_CIRCLE
			circle.momx = mobj.momx
			circle.momy = mobj.momy
			circle.momz = mobj.momz
		end
		
		if player.secondjump == 1
			S_StartSound(player.mo, sfx_tdslow)
			if circle
				circle.scale = $/2
			else
				tdcircle(mobj, MT_THOK, 4*mobj.scale,
				FixedDiv(mobj.height,mobj.scale), mobj.scale/8, true, mobj.color,
				false, mobj.angle)
			end
		else
			S_StartSoundAtVolume(player.mo, sfx_s3k7c, 64)
			if circle
				circle.scale = $*2/3
			else
				tdcircle(mobj, MT_THOK, 8*mobj.scale,
				FixedDiv(mobj.height/2,mobj.scale), mobj.scale/8, true, mobj.color,
				false, mobj.angle)
			end
		end
	end
	return true
end, MT_TAILSDOLL_CRYSTAL)

//Thinker for all the other parts
addHook("MobjThinker", function(mobj)
	if not mobj.health or mobj.fuse
		mobj.flags = $&~MF_NOGRAVITY&~MF_NOCLIP&~MF_NOCLIPHEIGHT
		mobj.rollangle = $+FixedAngle(R_PointToDist2(0,0, R_PointToDist2(0,0, mobj.momx, mobj.momy),mobj.momz))*2
		mobj.sprite = SPR_TDLP
		//Head
		if mobj.reactiontime == 1
			mobj.frame = 5
		elseif mobj.reactiontime >= 3
			//Tails
			if mobj.reactiontime >= 7
				mobj.frame = 6
			//Feet
			elseif mobj.reactiontime >= 5
				mobj.frame = 1
			//Hands
			else
				mobj.frame = mobj.reactiontime
			end
		//Body
		elseif mobj.reactiontime
			mobj.frame = 0
		end
		if P_IsObjectOnGround(mobj)
			mobj.momz = mobj.lastlook*2/-3
		else
			mobj.lastlook = mobj.momz
		end
		return
	end
	
	if not mobj.reactiontime return end
	
	if not mobj.tracer and mobj.hprev and mobj.hprev.valid and mobj.hprev.tracer
		mobj.tracer = mobj.hprev.tracer
		mobj.flags2 = $|MF2_LINKDRAW
	end
	
	if not (mobj.target and mobj.target.valid
	and mobj.hprev and mobj.hprev.valid
	and mobj.tracer and mobj.tracer.valid and mobj.tracer.player)
		P_KillMobj(mobj)
	return end
	
	if mobj.reactiontime == 1
		if mobj.tracer.player.panim == PA_PAIN
			mobj.angle = $+ANGLE_45
		else
			mobj.angle = mobj.tracer.player.drawangle
		end
	else
		mobj.angle = mobj.target.angle
	end
	mobj.color = mobj.tracer.color
	mobj.colorized = mobj.tracer.colorized
	mobj.scale = mobj.tracer.scale
	mobj.flags2 = mobj.target.flags2&(MF2_DONTDRAW|MF2_OBJECTFLIP)
	mobj.eflags = mobj.target.eflags&MFE_VERTICALFLIP
	
	mobj.sprite = SPR_TDLP
	
	local pulldist = mobj.scale/2
	if P_IsObjectOnGround(mobj)
		pulldist = $*3/2
	end
	//Head
	if mobj.reactiontime == 1
		pulldist = $/3
		mobj.frame = 5
	elseif mobj.reactiontime >= 3
		//Tails
		if mobj.reactiontime >= 7
			pulldist = $*6/10
			mobj.frame = 6
		//Feet
		elseif mobj.reactiontime >= 5
			pulldist = $*9/10
			mobj.frame = 1
		//Hands
		else
			pulldist = $*4/5
			mobj.frame = mobj.reactiontime
		end
	//Body
	else
		pulldist = $*7/10
		mobj.frame = 0
	end
	
	mobj.momz = $-mobj.tracer.momz/4
	
	local xdist = mobj.target.x - mobj.x
	+ P_ReturnThrustX(nil, mobj.angle+ANGLE_90, mobj.threshold*mobj.scale)
	local ydist = mobj.target.y - mobj.y
	+ P_ReturnThrustY(nil, mobj.angle+ANGLE_90, mobj.threshold*mobj.scale)
	
	local dist = R_PointToDist2(0,0, xdist,ydist)
	
	local zdist = mobj.z + mobj.height - mobj.target.z
	- mobj.cusval*mobj.scale*P_MobjFlip(mobj)
	if mobj.eflags&MFE_VERTICALFLIP
		zdist = $-mobj.height-mobj.target.height
	end
	
	local momz = abs(mobj.tracer.momz)
	if P_IsObjectOnGround(mobj.tracer)
		momz = $ + abs(mobj.tracer.pmomz)
	end
	
	local tailmomx = mobj.momx
	local tailmomy = mobj.momy
	
	if dist > pulldist*48
		P_Thrust(mobj, mobj.angle, TDDiv(momz, dist/-6, mobj.scale))
	elseif not (mobj.tracer.player.pflags&PF_STARTJUMP)
	and mobj.tracer.momz*P_MobjFlip(mobj.tracer) <= 0
		P_Thrust(mobj, mobj.angle, momz/-2)
	else
		P_Thrust(mobj, mobj.angle, momz/-8)
	end
	
	if mobj.reactiontime >= 7
		mobj.momx = $/2+tailmomx/2
		mobj.momy = $/2+tailmomy/2
	end
	
	local speed = R_PointToDist2(0,0, mobj.momx, mobj.momy)
	
	local angledif = abs(mobj.angle-R_PointToAngle2(mobj.x, mobj.y, mobj.target.x, mobj.target.y))
	
	//Angled sprites
	if mobj.reactiontime >= 7
	and mobj.target.momz*P_MobjFlip(mobj.target) < -8*mobj.target.scale
		mobj.frame = 17
	elseif (((abs(zdist) > mobj.scale*8/3
	or (mobj.tracer.eflags & MFE_UNDERWATER and abs(zdist) > mobj.scale*8/4))
	and (angledif < ANGLE_67h or angledif > ANGLE_112h))
	or mobj.tracer.player.pflags&PF_SPINNING)
	and mobj.reactiontime != 3 and mobj.reactiontime != 4
		//Head
		if mobj.reactiontime == 1
			mobj.frame = 13
		//Body
		elseif mobj.reactiontime == 2
			mobj.frame = 8
		//Tails
		elseif mobj.reactiontime >= 7
			mobj.frame = 16
		//Feet
		else
			mobj.frame = 10
		end
		
		if angledif > ANGLE_90 and not (mobj.tracer.player.pflags&PF_SPINNING)
			if mobj.reactiontime >= 7
				mobj.frame = 6
			else
				mobj.frame = $+1
			end
		end
	end
	
	if mobj.reactiontime == 1
		if mobj.tracer.player.panim == PA_PAIN
			mobj.frame = 15
		elseif mobj.tracer.state == S_PLAY_GASP
			mobj.frame = 14
		end
	end
	
	zdist = $ - max(abs(speed/6),mobj.scale)*P_MobjFlip(mobj)
	
	if mobj.reactiontime >= 7
		xdist = $ - P_ReturnThrustX(nil, mobj.angle, mobj.radius*2/3)
		ydist = $ - P_ReturnThrustY(nil, mobj.angle, mobj.radius*2/3)
		mobj.angle = $-mobj.threshold*ANGLE_11hh*2/3
		if mobj.frame == 16
			mobj.angle = $+mobj.threshold*ANGLE_11hh*2/3/2
		end
	elseif mobj.reactiontime == 2
		xdist = $ - P_ReturnThrustX(nil, mobj.angle, mobj.radius/4)
		ydist = $ - P_ReturnThrustY(nil, mobj.angle, mobj.radius/4)
	end
	
	if dist > pulldist
		mobj.momx = $*3/5+TDDiv(xdist*5/4, pulldist*10, mobj.scale)
		mobj.momy = $*3/5+TDDiv(ydist*5/4, pulldist*10, mobj.scale)
	end
	if abs(zdist) > pulldist
		if (mobj.tracer.player.speed < mobj.scale and P_IsObjectOnGround(mobj.tracer)
		and abs(mobj.momz) < mobj.scale*4)
		or (mobj.tracer.eflags & MFE_JUSTHITFLOOR and mobj.tracer.eflags&MFE_ONGROUND)
			mobj.momz = ($*3/5)-TDDiv(zdist*5/4, pulldist*10, mobj.scale)
		else
			mobj.momz = ($/4)-TDDiv(zdist*2, pulldist*10, mobj.scale)
		end
	end
	
	if dist > pulldist*256 or mobj.tracer.flags&MF_NOCLIP
		if dist > pulldist*512
			P_TeleportMove(mobj,mobj.tracer.x,mobj.tracer.y,mobj.tracer.z)
			mobj.momx = 0
			mobj.momy = 0
			mobj.momz = 0
		end
		mobj.flags = $|MF_NOCLIP
	elseif mobj.flags&MF_NOCLIP
		mobj.flags = $&~MF_NOCLIP
	end
	
	if abs(zdist) > pulldist*256 or mobj.tracer.flags&MF_NOCLIPHEIGHT
		if abs(zdist) > pulldist*512
			P_TeleportMove(mobj,mobj.tracer.x,mobj.tracer.y,mobj.tracer.z)
			mobj.momx = 0
			mobj.momy = 0
			mobj.momz = 0
		end
		mobj.flags = $|MF_NOCLIPHEIGHT
	elseif mobj.flags&MF_NOCLIPHEIGHT
		mobj.flags = $&~MF_NOCLIPHEIGHT
	end
end, MT_TAILSDOLL_PART)

addHook("MobjDeath", function(mobj)
	if not (mobj.tracer and mobj.tracer.valid and not mobj.tracer.health) P_RemoveMobj(mobj) return end
	if mobj.reactiontime == 1
		local stupid = P_SpawnMobjFromMobj(mobj,0,0,0,MT_FBOMB)
		stupid.flags = $|MF_NOCLIP|MF_NOCLIPTHING|MF_NOCLIPHEIGHT&~MF_MISSILE
		P_KillMobj(stupid)
		if mobj.tracer.player and mobj.tracer.player.tdsecret
			S_StartSound(stupid, sfx_tdexpl)
		else
			S_StartSound(stupid, stupid.info.deathsound)
		end
	end
	mobj.fuse = TICRATE*5
	mobj.health = 0
	P_InstaThrust(mobj, FixedAngle(P_RandomFixed()*360), P_SignedRandom()*mobj.scale/32)
	P_SetObjectMomZ(mobj, FRACUNIT*4+P_RandomFixed()*12, false)
end, MT_TAILSDOLL_PART)

addHook("MobjFuse", function(mobj)
	local ghost = P_SpawnGhostMobj(mobj)
	ghost.rollangle = mobj.rollangle
end, MT_TAILSDOLL_PART)

//Draw the links and ghosts
addHook("PostThinkFrame", do
	for player in players.iterate
		if player.realmo and player.realmo.valid
		and player.realmo.skin == "tailsdoll"
		and player.followmobj and player.followmobj.valid
		and player.followmobj.tailsdollparts != nil
			for i, mobj in ipairs(player.followmobj.tailsdollparts)
				if mobj and mobj.valid and not (mobj.flags2&MF2_DONTDRAW)
					//Links
					if mobj.reactiontime != 2
					and mobj.reactiontime < 7
						drawinbetween(mobj, mobj.target, 0, 2,
						mobj.threshold*mobj.scale, mobj.cusval*mobj.scale)
					end
					
					//Shields
					if leveltime%2 and (player.pflags&PF_SHIELDABILITY
					or (player.pflags&PF_JUMPED and not (player.pflags&PF_NOJUMPDAMAGE)))
						mobj.color = GetTDShieldColor(player)
						mobj.colorized = true
						P_SpawnGhostMobj(mobj)
					end
					
					//Afterimages
					if (player.powers[pw_super] or player.powers[pw_sneakers])
					and (player.speed + abs(player.mo.momz)) > FixedMul(20*FRACUNIT,player.mo.scale)
						local gmobj = P_SpawnGhostMobj(mobj)
						gmobj.fuse = 2
						if (leveltime & 1)
							gmobj.frame = $&~FF_TRANSMASK
							gmobj.frame = $|tr_trans70<<FF_TRANSSHIFT
						end
					end
				end
			end
		end
		
		//For the shield visuals
		/*if player.dollshield and player.dollshield.valid
		and player.dollshield.parts != nil
			for v, part in ipairs(player.dollshield.parts)
				if part and part.valid
					if part.threshold
						local i = 1 while i <= 4
							if player.dollshield.parts[i] and player.dollshield.parts[i].valid
								drawinbetween(part, player.dollshield.parts[i], 1, 10, 0, 0)
							end
							i = $+1
						end
					elseif part.tracer and part.tracer.valid
						drawinbetween(part, part.tracer, 1, 8, 0, 0)
					end
				end
			end
		end*/
	end
end)

// lol robe code
addHook("ShouldDamage", function(target, inflictor, source, damage, damagetype)
	if not target or not target.valid or target.skin ~= "tailsdoll"
	or not target.player or target.player.powers[pw_carry] & CR_NIGHTSMODE
	or damagetype&DMG_DEATHMASK then
		return
	end
	
	local inflictorvalid = inflictor and inflictor.valid
	local sourcevalid = source and source.valid

	// Spikes below us? What are those?
	if inflictorvalid then
		local inflictorflip = inflictor.eflags & MFE_VERTICALFLIP
		local targetflip = target.eflags & MFE_VERTICALFLIP

		if inflictor.type == MT_SPIKE // It's a spike?
		and inflictorflip == targetflip then // Same vertical flipping?
			return false
		end
	end

	// Sector fire, electric, or spike damage? Nope.
	if target.eflags & MFE_ONGROUND // On ground?
	and not inflictorvalid // No inflictor?
	and not sourcevalid // No source?
	// Fire or spike damage?
	and ((damagetype == DMG_FIRE and not (target.eflags & MFE_UNDERWATER))
	or damagetype == DMG_ELECTRIC
	or damagetype == DMG_SPIKE) then
		return false
	end
	
	//Parry it if it's not one of the above
	return shieldparry(target, inflictor, source)	
end, MT_PLAYER)

//Attack during shield abilities
addHook("PlayerCanDamage", function(player)
	if player.mo and player.mo.valid and player.mo.skin == "tailsdoll"
		if not P_IsObjectOnGround(player.mo) and not P_PlayerInPain(player)
		and (player.powers[pw_shield] & SH_NOSTACK) and player.pflags&PF_SHIELDABILITY
			return true
		elseif player.dollshield and player.dollshield.valid
			return true
		end
	end
end)

//Jumping
addHook("JumpSpecial", function(player)
	if not (player.mo and player.mo.valid and player.mo.skin == "tailsdoll") return end
	
	if P_PlayerInPain(player)
	or player.exiting
	or player.spectator
	or player.playerstate
	or not player.mo.health
	or player.powers[pw_super] == 1
	or player.iseggrobo
	or player.isjettysyn
	or player.guard
	or player.actionstate
	or player.tumble
	or player.powers[pw_nocontrol]
	or player.powers[pw_carry] == CR_MACESPIN
	or player.powers[pw_carry] == CR_PTERABYTE
	or player.pflags & (PF_JUMPSTASIS|PF_SLIDING)
	return end
	
	if (P_IsObjectOnGround(player.mo) or player.powers[pw_carry])
	and not (player.pflags&PF_JUMPDOWN)
		player.fly1 = (player.gotflag or player.gotcrystal) and 10 or 20
		if P_IsObjectOnGround(player.mo) and player.mo.pmomz
		and player.mo.pmomz*P_MobjFlip(player.mo) > 0
			player.mo.momz = player.mo.pmomz
			player.mo.z = $+player.mo.momz
			player.mo.eflags = $&~MFE_APPLYPMOMZ
		else
			player.mo.momz = 0
		end
		if player.mo.momz*P_MobjFlip(player.mo)+player.mo.scale*5/4
		< -P_GetMobjGravity(player.mo)*P_MobjFlip(player.mo)
			player.mo.momz = $+-2*P_GetMobjGravity(player.mo)*P_MobjFlip(player.mo)
		end
		player.pflags = $|PF_STARTJUMP|PF_JUMPED|PF_NOJUMPDAMAGE&~PF_SPINNING
		S_StartSound(player.mo, (player.gotflag or player.gotcrystal) and sfx_tdjmp2 or sfx_tdjump)
		player.powers[pw_carry] = CR_NONE
		if player.mo.tracer and player.mo.tracer.valid
			if (player.mo.tracer.flags & MF_MISSILE)
				player.mo.tracer.target = nil
			end
			player.mo.tracer = nil
		end
	elseif player.secondjump != 1 and not player.fly1
	and not player.gotflag and not player.gotcrystal and not srb2p
	and player.exhaustmeter != 0 and (not (player.pflags&PF_JUMPDOWN)
	or (player.mo.momz*P_MobjFlip(player.mo) <= player.mo.height/8
	and player.pflags&PF_JUMPED and not (player.pflags&PF_SHIELDABILITY) and not player.secondjump))
		player.secondjump = 1
		player.glidetime = -1
		player.pflags = $&~PF_SHIELDABILITY|PF_NOJUMPDAMAGE
		player.mo.state = S_PLAY_FALL
	end
	
	if player.fly1 and player.exhaustmeter != 0
		if player.mo.eflags & MFE_UNDERWATER
			player.mo.momz = $+player.mo.scale*5/7*P_MobjFlip(player.mo)
		else
			player.mo.momz = $+player.mo.scale*5/4*P_MobjFlip(player.mo)
		end
		player.fly1 = $-1
	elseif player.secondjump == 1
		player.glidetime = $+1
		if player.pflags&PF_SHIELDABILITY or player.exhaustmeter == 0
			player.secondjump = 0
		end
	end
	
	return true
end)

addHook("ShieldSpecial", function(player)
	if not (player.mo and player.mo.valid and player.mo.skin == "tailsdoll") return end
	
	//No using shields unless you're holding jump or have the poly shield up!
	if not ((player.powers[pw_shield] & SH_NOSTACK) > 1
	and (player.powers[pw_shield] & SH_NOSTACK) != SH_PINK and player.cmd.buttons&BT_JUMP
	and not (player.pflags&PF_SHIELDABILITY)
	and not (player.pflags&PF_THOKKED and ((player.powers[pw_shield] & SH_NOSTACK) != SH_BUBBLEWRAP or player.secondjump == 1)))
	or (player.dollshield and player.dollshield.valid) or SKINVARS_NOSPINSHIELD
		return true
	end
	
	player.pflags = $|PF_SHIELDABILITY&~PF_NOJUMPDAMAGE
end)

//Poly Barrier
addHook("SpinSpecial", function(player)
	if not (player.mo and player.mo.valid and player.mo.skin == "tailsdoll") return end
	
	if srb2p
	or P_PlayerInPain(player)
	or player.pflags & PF_SLIDING
	or player.exiting
	or player.powers[pw_carry]
	or player.spectator
	or player.playerstate
	or not player.mo.health
	or player.panim == PA_PAIN
	or player.powers[pw_super] == 1
	or player.iseggrobo
	or player.isjettysyn
	or player.guard
	or player.actionstate
	or player.tumble
	or player.powers[pw_nocontrol]
	or P_SuperReady(player)
	or player.pflags & PF_STASIS
	or player.pflags & PF_SPINDOWN
	or (player.dollshield and player.dollshield.valid)
	or player.dolldelay
	or ((player.powers[pw_shield] & SH_NOSTACK) > 1
	and (player.powers[pw_shield] & SH_NOSTACK) != SH_PINK and player.cmd.buttons&BT_JUMP
	and not SKINVARS_NOSPINSHIELD and not (player.pflags&PF_SHIELDABILITY)
	and not (player.pflags&PF_THOKKED and ((player.powers[pw_shield] & SH_NOSTACK) != SH_BUBBLEWRAP or player.secondjump == 1)))
	return end
	
	player.dolldelay = TICRATE
	
	player.dollshield = P_SpawnPlayerMissile(player.mo, MT_TAILSDOLL_SHIELD)
	if player.dollshield and player.dollshield.valid
		if tdnosplat(player)
			player.dollshield.scale = $*3/2
		end
		player.dollshield.scalespeed = player.dollshield.scale/6
		P_SetScale(player.dollshield, player.dollshield.scalespeed)
		player.dollshield.fuse = TICRATE*2/3
		if player.followmobj and player.followmobj.valid
			P_TeleportMove(player.dollshield, player.followmobj.x, player.followmobj.y, player.followmobj.z)
		end
		if player.followmobj and player.followmobj.valid
		and player.followmobj.tailsdollparts != nil
		and player.followmobj.tailsdollparts[2]
		and player.followmobj.tailsdollparts[2].valid
			player.dollshield.tracer = player.followmobj.tailsdollparts[2]
		end
		if player.tdsecret
			S_StartSoundAtVolume(player.mo, sfx_tdshn1, 128)
			player.dollshield.sprite = SPR_TDSH
			player.dollshield.frame = 4
			return
		else
			S_StartSoundAtVolume(player.mo, sfx_tdshld, 192)
			if tdnosplat(player)
				player.dollshield.state = S_TAILSDOLL_SHIELD
				return
			end
		end
		player.dollshield.parts = {}
		
		local i = 1 while i <= 16
			local part = P_SPMAngle(player.mo, MT_THOK, player.drawangle+(i*ANGLE_90))
			player.dollshield.parts[i] = part
			if part and part.valid
				part.state = S_INVISIBLE
				part.sprite = SPR_THOK
				part.target = player.dollshield
				part.reactiontime = i
				P_ColorTeamMissile(part, player)
				
				part.flags2 = $|MF2_SPLAT
				part.renderflags = RF_SLOPESPLAT|RF_NOSPLATBILLBOARD
				P_CreateFloorSpriteSlope(part)
			end
			i = $+1
		end
		
		
		/*local i = 1 while i <= 6
			player.dollshield.parts[i] = P_SPMAngle(player.mo, MT_THOK, player.drawangle+(i*ANGLE_90))
			if player.dollshield.parts[i] and player.dollshield.parts[i].valid
				if i > 4
					player.dollshield.parts[i].threshold = i-4
				elseif i and player.dollshield.parts[i-1] and player.dollshield.parts[i-1].valid
					player.dollshield.parts[i].tracer = player.dollshield.parts[i-1]
					player.dollshield.parts[i].threshold = 0
				end
				player.dollshield.parts[i].state = S_INVISIBLE
				player.dollshield.parts[i].target = player.dollshield
				player.dollshield.parts[i].reactiontime = 0
				P_ColorTeamMissile(player.dollshield.parts[i], player)
			end
			i = $+1
		end
		if player.dollshield.parts[1] and player.dollshield.parts[1].valid
		and player.dollshield.parts[4] and player.dollshield.parts[4].valid
			player.dollshield.parts[1].tracer = player.dollshield.parts[4]
		end*/
	end
end)

addHook("MobjThinker", function(mobj)
	if not (mobj.target and mobj.target.valid
	and mobj.target.player
	and mobj.target.player.dollshield == mobj)
		P_RemoveMobj(mobj)
		return
	end
	
	local innercolor = GetTDShieldColor(mobj.target.player, true)
	mobj.colorized = false
	if mobj.target.player.tdsecret
		mobj.color = SKINCOLOR_CYAN
		innercolor = SKINCOLOR_CYAN
		if leveltime%4 > 1
			mobj.colorized = true
		end
	else
		mobj.color = GetTDShieldColor(mobj.target.player)
	end
	
	if mobj.fuse == mobj.scale/mobj.scalespeed
		mobj.destscale = 1
		if mobj.target.player.tdsecret
			if not S_SoundPlaying(mobj.target, sfx_tdshn2)
				S_StartSoundAtVolume(mobj.target, sfx_tdshn2, 64)
			end
		elseif not S_SoundPlaying(mobj.target, sfx_tdlose)
			S_StartSound(mobj.target, sfx_tdlose)
		end
	end
	
	local flipped = 1
	local istracer = 0
	if mobj.tracer and mobj.tracer.valid
		flipped = P_MobjFlip(mobj.tracer)
		istracer = 1+FRACUNIT*-16
	elseif mobj.target and mobj.target.valid
		flipped = P_MobjFlip(mobj.target)
	else
		P_RemoveMobj(mobj)
		return
	end
	
	if flipped == -1
		A_CapeChase(mobj,istracer,0)
	else
		A_CapeChase(mobj,istracer+FRACUNIT*-24,0)
	end
	if not (mobj and mobj.valid) return end
	
	if tdnosplat(mobj.target.player)
	and mobj.fuse%2 and mobj.scale != mobj.destscale
		P_SpawnGhostMobj(mobj)
	end
	
	if not mobj.parts return end
	for v, part in ipairs(mobj.parts)
		if part and part.valid
			part.tics = mobj.fuse+1
			part.scale = mobj.scale
			part.color = mobj.color
			part.colorized = mobj.colorized
			part.target = mobj
			//if part.threshold
			//	if part.threshold == 2
			//		P_TeleportMove(part,mobj.x,mobj.y,mobj.z+mobj.height)
			//	else
			//		P_TeleportMove(part,mobj.x,mobj.y,mobj.z)
			//	end
			//else
			part.angle = $ - ANGLE_180
			A_Custom3DRotate(part, 32*FRACUNIT + 48, FRACUNIT*96)
			part.angle = $ - ANGLE_180
			//end
			if mobj.eflags & MFE_VERTICALFLIP
				part.z = $ + 24*part.scale
			end
			
			if part.reactiontime%8 < 4
				part.z = $ + 5*part.scale
				part.floorspriteslope.zdelta = FRACUNIT*3/2
				part.floorspriteslope.xydirection = part.angle
			else
				part.z = $ - 5*part.scale
				part.floorspriteslope.zdelta = FRACUNIT*-3/2
				part.floorspriteslope.xydirection = part.angle
			end
			local o = {x = part.x, y = part.y, z = part.z}
			part.floorspriteslope.o = o
			
			part.spritexscale = FRACUNIT*3/2
			part.spriteyscale = FRACUNIT*2/3
			
			part.sprite = SPR_TDSH
			if part.reactiontime > 8
				part.frame = 5
				part.blendmode = AST_ADD
				part.color = innercolor
				
				if mobj.fuse%2 and mobj.scale != mobj.destscale
					local ghost = P_SpawnGhostMobj(part)
					
					ghost.blendmode = part.blendmode
					ghost.spritexscale = part.spritexscale
					ghost.spriteyscale = part.spriteyscale
					
					//OpenGL-only due to lag
					/*if CV_FindVar("renderer").value > 1
						ghost.flags2 = $|MF2_SPLAT
						ghost.renderflags = RF_SLOPESPLAT|RF_NOSPLATBILLBOARD
						P_CreateFloorSpriteSlope(ghost)
						
						ghost.floorspriteslope.zdelta = part.floorspriteslope.zdelta
						ghost.floorspriteslope.xydirection = part.floorspriteslope.xydirection
						
						ghost.floorspriteslope.o = o
					else*/
						P_TeleportMove(ghost,
						ghost.x + P_ReturnThrustX(nil, part.angle, 32*part.scale),
						ghost.y + P_ReturnThrustY(nil, part.angle, 32*part.scale),
						ghost.z)
						ghost.spriteyscale = FRACUNIT
						ghost.spriteyoffset = -24*FRACUNIT
						if part.reactiontime%8 < 4
							ghost.spriteyoffset = -$
							ghost.frame = $|FF_VERTICALFLIP
						end
						ghost.spriteyoffset = $ + 32*FRACUNIT
					//end
				end
			else
				part.frame = 6
			end
		end
	end
end, MT_TAILSDOLL_SHIELD)

addHook("MobjRemoved", function(mobj)
	if not mobj.parts return end
	for v, part in ipairs(mobj.parts)
		if part and part.valid
			P_RemoveMobj(part)
		end
	end
end, MT_TAILSDOLL_SHIELD)

//Destroy spikes via the shield
local waterspike = function(thing, tmthing)
	if not (thing and thing.valid and tmthing and tmthing.valid) return end
	if tmthing.player and tmthing.skin == "tailsdoll"
	and tmthing.player.dollshield and tmthing.player.dollshield.valid
	and thing.z - thing.scale <= tmthing.z + tmthing.height
	and thing.z + thing.height + thing.scale >= tmthing.z
		P_KillMobj(thing, tmthing)
		return true
	end
end
addHook("MobjCollide", function(thing, tmthing) waterspike(thing, tmthing) end, MT_SPIKE)
addHook("MobjCollide", function(thing, tmthing) waterspike(thing, tmthing) end, MT_WALLSPIKE)

addHook("MobjDamage", function(target, inflictor)
	if inflictor and inflictor.valid and inflictor.player
	and inflictor.skin == "tailsdoll"
	and inflictor.player.dollshield and inflictor.player.dollshield.valid
		shieldblock(inflictor)
		inflictor.momz = abs($)*P_MobjFlip(inflictor)
	end
end)

addHook("MobjDeath", function(target, inflictor)
	if target and target.valid and target.flags&MF_MONITOR
	and inflictor and inflictor.valid and inflictor.player
	and inflictor.skin == "tailsdoll"
	and inflictor.player.dollshield and inflictor.player.dollshield.valid
		shieldblock(inflictor)
		inflictor.momz = abs($)*P_MobjFlip(inflictor)
	end
end)

//Wall Breaker Function
local wallbreak = function(mobj, sectorthing)
	local nerds = false
	for fof in sectorthing.ffloors()
		if fof.valid and (fof.flags & FF_BUSTUP) and (fof.flags & FF_EXISTS)
			local foffloor = fof.topheight
			local fofceiling = fof.bottomheight
			if fof.b_slope and fof.b_slope.valid
				fofceiling = P_GetZAt(fof.b_slope, mobj.x, mobj.y)
			end
			if fof.t_slope and fof.t_slope.valid
				foffloor = P_GetZAt(fof.t_slope, mobj.x, mobj.y)
			end
			if foffloor >= mobj.z and fofceiling <= mobj.z+mobj.height
				EV_CrumbleChain(nil, fof)
				if fof.master.flags & ML_EFFECT5
					P_LinedefExecute(P_AproxDistance(fof.master.dx, fof.master.dy)>>FRACBITS, mobj, sectorthing)
				end
				return true
			end
		end
	end
end

//Wall Breaker
addHook("MobjLineCollide", function(mobj, line)
	if not (line and line.valid and mobj and mobj.valid
	and mobj.player and mobj.skin == "tailsdoll"
	and mobj.player.dollshield and mobj.player.dollshield.valid) return end
	local killone = false
	local killtwo = false
	if line.frontsector and line.frontsector.valid then killone = wallbreak(mobj, line.frontsector) end
	if line.backsector and line.backsector.valid then killtwo = wallbreak(mobj, line.backsector) end
	if killone or killtwo
		shieldblock(mobj)
		if mobj.player.speed > 25*mobj.scale
			P_InstaThrust(mobj, R_PointToAngle2(0,0,mobj.momx, mobj.momy), 20*mobj.scale)
		end
		P_BounceMove(mobj)
	end
end, MT_PLAYER)

//Finally the main thinker!
addHook("PlayerThink", function(player)
	if not (player.mo and player.mo.valid and player.mo.skin == "tailsdoll") return end
	
	player.cantrick = false
	player.tdparries = 0
	
	if player.shieldscale != 0
		player.shieldscale = 0
	end
	
	if player.powers[pw_super] != 1 and player.powers[pw_carry] != CR_NIGHTSMODE
		player.mo.sprite = 0
	end
	
	if (S_SoundPlaying(player.mo, sfx_tdjump)
	or S_SoundPlaying(player.mo, sfx_tdjmp2)) and not player.fly1
	and not (player.pflags&PF_JUMPED and player.pflags&PF_STARTJUMP)
		S_StopSoundByID(player.mo, sfx_tdjump)
		S_StopSoundByID(player.mo, sfx_tdjmp2)
	end
	
	if player.dollshield and player.dollshield.valid
		if not player.mo.health or player.tumble
		or player.guard or player.airdodge
			P_KillMobj(player.dollshield)
			player.dollshield = nil
		else
			nuketdshield(player, 72*player.mo.scale)
			if player.mo.eflags & MFE_SPRUNG
				shieldblock(player.mo)
				player.mo.momz = $*5/4
				player.mo.momx = $*5/4
				player.mo.momy = $*5/4
				S_StartSound(player.mo, sfx_sprong)
			elseif player.mo.subsector and player.mo.subsector.valid
			and player.mo.subsector.sector and player.mo.subsector.sector.valid
				local crumble = false
				for fof in player.mo.subsector.sector.ffloors()
					if not (fof.flags & FF_EXISTS) continue end -- Does it exist?
					if not (fof.flags & FF_BUSTUP) continue end -- Is it bustable?
					
					if player.mo.z + player.mo.momz + player.mo.height < fof.bottomheight continue end -- Are we too low?
					if player.mo.z + player.mo.momz > fof.topheight continue end -- Are we too high?  
					
					crumble = true
					EV_CrumbleChain(fof) -- Crumble
				end
				if crumble
					shieldblock(player.mo)
					player.mo.momz = $*-1
				end
			end
		end
	end
	
	if player.dolldelay
		player.dolldelay = $-1
		if not player.dolldelay and player.followmobj and player.followmobj.valid
			local spoark = P_SpawnMobjFromMobj(player.followmobj, 0, 0, 0, MT_OVERLAY)
			spoark.state = S_SSPK1
			spoark.spritexscale = $ and $/2 or FRACUNIT/2
			spoark.spriteyscale = $ and $/2 or FRACUNIT/2
			spoark.target = player.followmobj
			if player.tdsecret
				S_StartSoundAtVolume(player.followmobj, sfx_tdshn3, 128)
			else
				S_StartSound(player.followmobj, sfx_tdrecg)
			end
		end
	end
	
	if P_PlayerInPain(player)
	or player.pflags & PF_SLIDING
	or player.exiting
	or player.powers[pw_carry]
	or player.spectator
	or player.playerstate
	or not player.mo.health
	or player.panim == PA_PAIN
	or player.powers[pw_super] == 1
	or player.iseggrobo
	or player.isjettysyn
	or player.guard
	or player.actionstate
	or player.tumble
	or player.powers[pw_nocontrol]
		if player.playerstate == PST_DEAD
			if player.deadtimer > 1
				player.mo.flags2 = $ | MF2_DONTDRAW
			end
			if not (player.mo.fuse % 8) //Prevent SF_MACHINE explosions
				player.mo.fuse = $-1
			end
			player.mo.momz = P_GetMobjGravity(player.mo)*-1
			player.mo.flags = $ | MF_NOGRAVITY & ~MF_NOCLIP & ~MF_NOCLIPHEIGHT
		end
		return
	end
	
	if player.fly1 and not (player.pflags&PF_STARTJUMP)
		player.fly1 = 0
	end
	
	local flip = P_MobjFlip(player.mo)
	if player.secondjump == 1 and player.mo.momz*flip < 0
		player.mo.momz = max($*3/2*flip, P_GetMobjGravity(player.mo)*6*flip)*flip
	end
end)